/*
	Layer Repeater-v1
	by ajk48n
	
	The script with take a selected layer, and make a precomp with a specified amount of duplicates of the same layer.
	There will then be controls in your main composition to control
	
	Number Visible
		Number of visible layers (Maximum is the amount entered when the script is run)
	Number Offset
		Offset of visible layers
	Position X Base
		The starting X position for the precomp
	Position Offset X
		The offset in X for the position of each of the duplicate layers
	Position Y Base
		The starting Y position for the precomp
	Position Offset Y
		The offset in Y for the position of each of the duplicate layers
	Rotation Base
		The starting rotation for the precomp
	Rotation Offset
		The offset for the rotation of each of the duplicate layers
	Scale Base
		The starting scale for the precomp
	Scale Offset
		The offset for the scale of each of the duplicate layers	
	Opacity Begin-End
		If checked, opacity will be derived from the Opacity Begin and Opacity End Sliders
		If unchecked, opacity will be derived from Opacity Base and Opacity Offset
	Opacity Begin
		The starting opacity of all the duplicate layers. This will start at your original layer that you ran the script on. (Only active if Opacity Begin-End is checked)
	Opacity End
		The ending opacity of all the duplicate layers. (Only active if Opacity Begin-End is checked)
	Opacity Base
		The starting opacity for the precomp (Only active if Opacity Begin-End is unchecked)
	Opacity Offset
		The offset for the opacity of each of the duplicate layers (Only active if Opacity Begin-End is unchecked)
		
		
	
	NOTES:
	
	There can only be 1 layer selected
	
	After the script is run, the new layer CAN NOT be put into a precomp
	
	There CAN NOT be another composition named the same as the one the script gets run on
	
	If the layer that the script is run on is a precomp, the layer MUST have a name, not the default one that is given when a layer is precomped
	
	add anchor point control to repeater layer
	
	add scale independence x and y
		
	
		
	BUG can't put new layers in front of original object
	work around, scale up original object with "Scale Base" slider to make it the front-most object
	
	BUG 
	a layer can''t have a name that is over 26 digits long, if 10,000 or more duplicate layers are made
	see "BUG LAYER NAME SIZE" below
		
*/


{
	
	app.beginUndoGroup("Layer Repeater");
	
	var currentComp = app.project.activeItem;
	var compName = currentComp.name;
	var compLayers = currentComp.layers;
	if (currentComp.selectedLayers.length != 1)
		alert("You must select exactly 1 layer");
	else {
	
	
		var win = new Window('dialog', 'Layer Repeater', "x:300,y:300,width:350,height:125");
		win.grp1 = win.add('group', [25,15,355,130], 'Title of Comp'); 
		win.grp1.titleSt = win.grp1.add('statictext', "x:15,y:15,width:150,height:20", 'Enter Number of Layers:');
		win.grp1.number_layers = win.grp1.add('edittext', "x:15,y:30,width:300,height:15", "<Number of Layers>");
		win.grp1.buildBtn = win.grp1.add('button', "x:15,y:50,width:150,height:30",	'Layer Repeater GO!!!', {name:'ok'});
		win.grp1.buildBtn.onClick = checkFields;
		win.grp1.cancelBtn = win.grp1.add('button', "x:200,y:50,width:100,height:30", 'Cancel', {name:'cancel'});
		win.show();

	}
	
	app.endUndoGroup();

}

function checkFields() {
	if (check_Number(win.grp1.number_layers, "Number of Layers"))
		make_repeater();
}

function check_Number(field, error_string) {
	if (isNaN(field.text)) {
		alert(error_string + " must be a number");
		field.text = 0;
		return 0;
	}
	return 1;
}
	
	
function make_repeater() {
	
	win.close();
	
	var selectedLayer = currentComp.selectedLayers[0];
	var selected_layer_name = selectedLayer.name;
	var selected_layer_position = selectedLayer.property("Transform").property("Position").value;
	var selected_layer_rotation = selectedLayer.property("Transform").property("Rotation").value;
	var selected_layer_scale = selectedLayer.property("Transform").property("Scale").value;
	var selected_layer_opacity = selectedLayer.property("Transform").property("Opacity").value;
	
	var precompose_layers = new Array();
	precompose_layers[0] = selectedLayer.index;
	
	var num_layers = win.grp1.number_layers.text;
	
	var repeater_layer_name = selected_layer_name.substring(0,20);
	var repeater_layer_name = repeater_layer_name + "-Repeater";
	
	
	var repeater_comp = compLayers.precompose(precompose_layers, repeater_layer_name, true);

	var repeater_comp_layers = repeater_comp.layers;
	var duplicate_layer = repeater_comp_layers[1];

	for (i=1;  i<num_layers; i++) {
		duplicate_layer.duplicate();
	}

	var repeater_layer = currentComp.selectedLayers[0];
	
	repeater_comp_layers = repeater_comp.layers;
	
	
	
	
	
	
	
	
	//add slider effects
	
	if (repeater_layer("Effects") != null) { 
	// Always best to check if it's safe before adding: 
		
		if (repeater_layer("Effects").canAddProperty("Slider Control")) { 
			
			var temp_number_visible = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_number_visible.name = "Number Visible";				
			
			var number_offset = repeater_layer("Effects").addProperty("Slider Control"); 
			number_offset.name = "Number Offset";				
			
			var temp_position_X_base = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_position_X_base.name = "Position X Base";

			var temp_position_offsetX = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_position_offsetX.name = "Position Offset X";	
			
			var temp_position_Y_base = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_position_Y_base.name = "Position Y Base";

			var temp_position_offsetY = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_position_offsetY.name = "Position Offset Y";
						
			var temp_rotation_base = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_rotation_base.name = "Rotation Base";			
			
			var temp_rotation_offset = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_rotation_offset.name = "Rotation Offset";
			
			var temp_scale_base = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_scale_base.name = "Scale Base";

			var temp_scale_offset = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_scale_offset.name = "Scale Offset";
			
			var temp_opacity_begin_end = repeater_layer("Effects").addProperty("Checkbox Control");
			temp_opacity_begin_end.name = "Opacity Begin-End";
			
			var temp_opacity_offset = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_opacity_offset.name = "Opacity Begin";
			
			var temp_opacity_offset = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_opacity_offset.name = "Opacity End";

			var temp_opacity_base = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_opacity_base.name = "Opacity Base";

			var temp_opacity_offset = repeater_layer("Effects").addProperty("Slider Control"); 
			temp_opacity_offset.name = "Opacity Offset";
			

			
		
			/*
				BUG, can't set all values here, because making more than one property at a time deletes the variable of the previous property
				search for effects again below
			*/
		}
	}

	var number_visible;
	var number_offset;
	var position_offsetX;
	var position_X_base;
	var position_offsetY;
	var position_Y_base;
	var rotation_offset;
	var rotation_base;
	var scale_offset;	
	var scale_base;
	var opacity_begin_end;
	var opacity_begin;
	var opacity_end;
	var opacity_offset;		
	var opacity_base;
	

	for (var i=1; i <= repeater_layer.numProperties; ++i) {

		if (repeater_layer.property(i).name == "Effects") {
			
			currentEffects = repeater_layer.property(i);
			
			for (var j=1; j <= currentEffects.numProperties; ++j) {
				
				if (currentEffects.property(j).name == "Number Visible")
					number_visible = currentEffects.property(j);
				if (currentEffects.property(j).name == "Number Offset")
					number_offset = currentEffects.property(j);				
				if (currentEffects.property(j).name == "Position Offset X")
					position_offsetX = currentEffects.property(j);
				if (currentEffects.property(j).name == "Position X Base")
					position_X_base = currentEffects.property(j);
				if (currentEffects.property(j).name == "Position Offset Y")
					position_offsetY = currentEffects.property(j);
				if (currentEffects.property(j).name == "Position Y Base")
					position_Y_base = currentEffects.property(j);
				if (currentEffects.property(j).name == "Rotation Offset")
					rotation_offset = currentEffects.property(j);
				if (currentEffects.property(j).name == "Rotation Base")
					rotation_base = currentEffects.property(j);
				if (currentEffects.property(j).name == "Scale Offset")
					scale_offset = currentEffects.property(j);
				if (currentEffects.property(j).name == "Scale Base")
					scale_base = currentEffects.property(j);
				if (currentEffects.property(j).name == "Opacity Begin-End")
					opacity_begin_end = currentEffects.property(j);
				if (currentEffects.property(j).name == "Opacity Begin")
					opacity_begin = currentEffects.property(j);
				if (currentEffects.property(j).name == "Opacity End")
					opacity_end = currentEffects.property(j);				
				if (currentEffects.property(j).name == "Opacity Offset")
					opacity_offset = currentEffects.property(j);
				if (currentEffects.property(j).name == "Opacity Base")
					opacity_base = currentEffects.property(j);				
			}
		}
	}

	number_visible.property(1).setValue(num_layers);	
	number_offset.property(1).setValue("0");
	position_offsetX.property(1).setValue("0");
	position_X_base.property(1).setValue(selected_layer_position[0]);
	position_offsetY.property(1).setValue("0");
	position_Y_base.property(1).setValue(selected_layer_position[1]);
	rotation_offset.property(1).setValue("0");
	rotation_base.property(1).setValue(selected_layer_rotation);
	scale_offset.property(1).setValue("100");
	scale_base.property(1).setValue(selected_layer_scale[0]);	
	opacity_begin_end.property(1).setValue("1");
	opacity_begin.property(1).setValue("100");
	opacity_end.property(1).setValue("0");	
	opacity_offset.property(1).setValue("100");
	opacity_base.property(1).setValue(selected_layer_opacity);
	
	
	
	
	//expressions
	
	
	for (var i=1;i<=num_layers;i++) {
		var current_layer = repeater_comp_layers[i];
		
		//BUG LAYER NAME SIZE if over 10,000 duplicates are made, the string size will be too large
		var current_layer_name = current_layer.name.substring(0,26);
		current_layer_name = current_layer_name + "-" + i;
		current_layer.name = current_layer_name;
		
		for (var j=1; j <= current_layer.numProperties; j++) {
			
			var current_property = current_layer.property(j);
			
			if (current_property.name == "Transform") {
				
				
				var position_property = current_property.Position;
				var rotation_property = current_property.Rotation;
				var scale_property = current_property.Scale;
				var opacity_property= current_property.Opacity;
				
				var split_number = 1; //1=1st element, if 0, the first element will move
				
				var current_number = i-split_number;
				
				if (position_property.canSetExpression) {
					

					var position_expression = 
					"offsetX = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Position Offset X\")(\"Slider\")*"+current_number+";\n" +
					"offsetY = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Position Offset Y\")(\"Slider\")*"+current_number+";\n" +
					"baseX = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Position X Base\")(\"Slider\");\n" +
					"baseY = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Position Y Base\")(\"Slider\");\n" +
					"[baseX+offsetX, baseY+offsetY]";
					


position_property.expression=position_expression;
					position_property.expressionEnabled=true;
				}
				if (rotation_property.canSetExpression) {
					
					var rotation_expression = 
					"rotationOffset = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Rotation Offset\")(\"Slider\");\n" + 
					"rotationBase = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Rotation Base\")(\"Slider\");\n" +
					"temp = rotationBase;\n" +
					"i=" + current_number + ";\n" +
					"for (j=0;j<i;j++) {\n" +
						"\tnewtemp = temp+rotationOffset;\n" +
						"\ttemp=newtemp;\n" +
					"}\n" +
					"temp";
					rotation_property.expression=rotation_expression;
					rotation_property.expressionEnabled=true;
				}
				if (scale_property.canSetExpression) {
					
					var scale_expression = 
					"scaleOffset = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Scale Offset\")(\"Slider\")/100;\n" + 
					"scaleBase = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Scale Base\")(\"Slider\");\n" +
					"temp = scaleBase;\n" +
					"i=" + current_number + ";\n" +
					"for (j=0;j<i;j++) {\n" +
						"\tnewtemp = temp*scaleOffset;\n" +
						"\ttemp=newtemp;\n" +
					"}\n" +
					"[temp, temp]";
					

					scale_property.expression=scale_expression;
					scale_property.expressionEnabled=true;
				}
				if (opacity_property.canSetExpression) {
					

					var opacity_expression = 
					"layer_number = " + i + ";\n" +
					"number_visible = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Number Visible\")(\"Slider\");\n" + 
					"number_offset = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Number Offset\")(\"Slider\");\n" + 
					"opacity_begin_end = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Opacity Begin-End\")(\"Checkbox\");\n" + 
					"opacity_begin = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Opacity Begin\")(\"Slider\");\n" + 
					"opacity_end = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Opacity End\")(\"Slider\");\n" + 
					"first_number = number_offset;\n" +
					"last_number = number_offset + number_visible;\n" +
					"number_difference = layer_number-first_number;\n" +
					"if (layer_number-1 < first_number || layer_number > last_number)\n" +
						"\ttemp=0;\n" +
					"else {\n" +
						"\t if (opacity_begin_end==1) {\n" +
							"\t\t if (number_visible > 1) {\n" +
								"\t\t\t opacity_difference = (opacity_end-opacity_begin)/(number_visible-1);\n" +					
								"\t\t\t opacityOffset = opacity_difference;\n" +
							"\t\t } else\n" +
								"\t\t\t opacityOffset = 0\n" +
							"\t\t temp = opacity_begin;\n" +
						"\t }\n" +
						"\t else {\n" +
							"\t\t opacityOffset = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Opacity Offset\")(\"Slider\")/100;\n" + 
							"\t\t opacityBase = comp(\"" + compName + "\").layer(\""+repeater_layer_name+"\").effect(\"Opacity Base\")(\"Slider\");\n" +
							"\t\t if (opacityOffset < 0)\n" +
								"\t\t\t opacityOffset=0;\n" +
							"\t\t else if (opacityOffset > 100)\n" +
								"\t\t\t opacityOffset = 100;\n" +
							"\t\t if (opacityBase < 0)\n" +
								"\t\t\t opacityBase=0;\n" +
							"\t\t else if (opacityBase > 100)\n" +
								"\t\t\t opacityBase = 100;\n" +
							"\t\t temp = opacityBase;\n" +
						"\t }\n" +
						"\t for (j=0;j<number_difference-1;j++) {\n" +
							"\t\t if (opacity_begin_end==1)\n" +
								"\t\t\t newtemp = temp+opacityOffset;\n" +
							"\t\t else\n" +
								"\t\t\t newtemp = temp*opacityOffset;\n" +
							"\t\t temp=newtemp;\n" +
						"\t}\n" +
					"}\n" +
					"temp";
					
					opacity_property.expression=opacity_expression;
					opacity_property.expressionEnabled=true;
				}
			}
		
		}
	}
	


}
	
